> For the complete documentation index, see [llms.txt](https://docs.trustlesswork.com/trustless-work/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.trustlesswork.com/trustless-work/v1-es/escrow-react-sdk/escrows/useinitializeescrow.md).

# useInitializeEscrow

Despliega el contrato escrow y define las propiedades del escrow.

## Uso

Este hook personalizado expone una función para desplegar un escrow.

{% code overflow="wrap" %}

```typescript
import { useInitializeEscrow } from "@trustless-work/escrow/hooks";
import { InitializeSingleReleaseEscrowPayload, InitializeMultiReleaseEscrowPayload } from "@trustless-work/escrow/types";

/*
 *  useInitializeEscrow 
*/
const { deployEscrow } = useInitializeEscrow();

/* 
 * Devuelve una transacción sin firmar
 * payload debe ser del tipo `InitializeMultiReleaseEscrowPayload` o `InitializeSingleReleaseEscrowPayload`
*/
const { unsignedTransaction } = await deployEscrow(payload);

```

{% endcode %}

### Función

`deployEscrow`\
Responsable de construir y devolver una transacción sin firmar basada en el payload proporcionado.

**EscrowType**: Especifica el tipo de escrow. Acepta los siguientes valores:

* **multi-release**: Permite múltiples liberaciones de fondos.
* **single-release**: Los fondos se liberan en una única transacción.

**InitializeSingleReleaseEscrowPayload:** Un objeto con los campos necesarios para inicializar un **single-release** escrow.

**InitializeMultiReleaseEscrowPayload:** Un objeto con los campos necesarios para inicializar un **multi-release** escrow.

**Parámetros**:

Asegúrate de que coincidan: si eliges un tipo "multi-release", también debes usar un payload "multi-release".

* **tipo**: Describe el tipo de escrow a utilizar. Las opciones son "multi-release" o "single-release".
* **payload**: Un objeto que contiene los campos requeridos para inicializar un escrow.

{% content-ref url="/pages/335aa7f3f4a0e28538f1e2453255e504bcb638e3" %}
[Desplegar](/trustless-work/v1-es/introduccion/developer-resources/tipos/cargas-utiles/desplegar.md)
{% endcontent-ref %}

*Valor de retorno:*

`unsignedTransaction`: Un objeto que representa la transacción construida, lista para ser firmada por tu billetera y transmitida.

***

## Ejemplo de uso

<pre class="language-typescript" data-title="src/hooks/useInitializeEscrowForm.ts" data-overflow="wrap"><code class="lang-typescript"><strong>import {
</strong>  useInitializeEscrow,
  useSendTransaction,
} from "@trustless-work/escrow/hooks";
import {
  InitializeMultiReleaseEscrowPayload,
  InitializeSingleReleaseEscrowPayload
} from "@trustless-work/escrow/types";

export const useInitializeEscrowForm = () => {

 /*
  *  useInitializeEscrow
 */
 const { deployEscrow } = useInitializeEscrow();
 
 /*
  *  useSendTransaction
 */
 const { sendTransaction } = useSendTransaction();

/*
 * función onSubmit, esto podría ser llamado por un botón de formulario
*/
 const onSubmit = async (payload: InitializeSingleReleaseEscrowPayload | InitializeMultiReleaseEscrowPayload) => {

    try {
      /**
       * Llamada a la API usando los hooks de trustless work
       * @Nota:
       * - Necesitamos pasar el payload a la función deployEscrow
       * - El resultado será una transacción sin firmar
       */
      const { unsignedTransaction } = await deployEscrow(
        payload,
        "multi-release"
        // o ...
        // "single-release"
      );

      if (!unsignedTransaction) {
        throw new Error(
          "La transacción sin firmar falta en la respuesta de deployEscrow."
        );
      }

      /**
       * @Nota:
       * - Necesitamos firmar la transacción usando tu [clave privada] como la billetera
       * - El resultado será una transacción firmada
       */
      const signedXdr = await signTransaction({ /* Este método debe ser proporcionado por la billetera */
        unsignedTransaction,
        address: walletAddress || "",
      });

      if (!signedXdr) {
        throw new Error("La transacción firmada falta.");
      }

      /**
       * @Nota:
       * - Necesitamos enviar la transacción firmada a la API
       * - Los datos serán un SendTransactionResponse
       */
      const data = await sendTransaction(signedXdr);

      /**
       * @Respuestas:
       * data.status === "SUCCESS"
       * - Escrow inicializado con éxito
       * - Mostrar una notificación de éxito
       *
       * data.status == "ERROR"
       * - Mostrar una notificación de error
       */
      if (data.status === "SUCCESS") {
        toast.success("Escrow creado");
      }
    } catch (error: unknown) {
      // lógica para capturar el error
    }
  };
}

</code></pre>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.trustlesswork.com/trustless-work/v1-es/escrow-react-sdk/escrows/useinitializeescrow.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
